#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <math.h>
#include "api.h"
#include "Alg.h"

int hex_char_value(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	else if (c >= 'a' && c <= 'f')
		return (c - 'a' + 10);
	else if (c >= 'A' && c <= 'F')
		return (c - 'A' + 10);
	return 0;
}

int hextodec(char * buff, int len) {
	int num = 0;
	for (int j = 0; j < len; j++) {
		num = num + hex_char_value(buff[j]) * pow((float)16, len - 1 - j);
	}
	return num;
}

int testpke() {

	FILE *fp = NULL;
	char buff[5000];
	unsigned char seed[48];

	unsigned char pk[CRYPTO_PUBLICKEYBYTES], pk_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char sk[CRYPTO_SECRETKEYBYTES], sk_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES], c_t[CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	//unsigned long long mlen = MESSAGE_LEN, clen = CRYPTO_CIPHERTEXTBYTES;
	unsigned long long pk_byts = 0, sk_byts = 0, m_byts = CRYPTO_BYTES, c_byts = 0;

	fopen_s(&fp, "PKE_VEC_INFO.dat", "r");
	//read seed_len
	int seed_len = 0, sk_len = 0, pk_len = 0, m_len = 0, c_len = 0, label = 0;

	//for (int i = 0; i < 8; i++) {
	fgets(buff, 9, (FILE*)fp);
	seed_len = hextodec(buff, 8);
	fgets(buff, (seed_len * 2 + 1), (FILE*)fp);
	for (j = 0; j < seed_len; j++) {
		seed[j] = hextodec(buff + 2 * j, 2);
	}
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {
		pke_keygen(pk, &pk_byts, sk, &sk_byts);
		rand_byts(CRYPTO_BYTES, k1);

		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, (sk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < sk_len; j++) {
			sk_t[j] = hextodec(buff + 2 * j, 2);
		}
		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		fgets(buff, (pk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pk_len; j++) {
			pk_t[j] = hextodec(buff + 2 * j, 2);
		}

		fgets(buff, 9, (FILE*)fp);
		m_len = hextodec(buff, 8);
		fgets(buff, (m_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < m_len; j++) {
			k2[j] = hextodec(buff + 2 * j, 2);
		}

		if (memcmp(sk_t, sk, CRYPTO_SECRETKEYBYTES) == 0) {
			//printf("\nsk_t is equal to sk. \n");
		}
		else {
			printf("\nsk_t is not equal to sk. \n");
			label = -1;
		}
		if (memcmp(pk_t, pk, CRYPTO_PUBLICKEYBYTES) == 0) {
			//printf("\npk_t is equal to pk. \n");
		}
		else {
			printf("\npk_t is not equal to pk. \n");
			label = -1;
		}

		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		pke_enc(pk_t, pk_byts, k2, m_byts, c, &c_byts);

		fgets(buff, 9, (FILE*)fp);
		c_len = hextodec(buff, 8);
		fgets(buff, (c_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < c_len; j++) {
			c_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(c, c_t, CRYPTO_CIPHERTEXTBYTES) == 0) {
			//printf("\nc is equal to c_t. \n");
		}
		else {
			printf("\nc is not equal to c_t. \n");
			label = -1;
		}

		pke_dec(sk_t, sk_byts, c_t, c_byts, k3, &m_byts);
		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}

int testkem() {

	FILE *fp = NULL;
	char buff[5000];
	unsigned char seed[48];

	unsigned char pk[CRYPTO_PUBLICKEYBYTES], pk_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char sk[CRYPTO_SECRETKEYBYTES], sk_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], c[CRYPTO_CIPHERTEXTBYTES], c_t[CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	unsigned long long pk_byts = 0, sk_byts = 0, ss_byts, c_byts = 0, label = 0;

	fopen_s(&fp, "KEM_VEC_INFO.dat", "r");

	int seed_len = 0, sk_len = 0, pk_len = 0, c_len = 0, ss_len = 0;
	//read seed_len
	fgets(buff, 9, (FILE*)fp);
	seed_len = hextodec(buff, 8);

	fgets(buff, (seed_len * 2 + 1), (FILE*)fp);
	for (j = 0; j < seed_len; j++) {
		seed[j] = hextodec(buff + 2 * j, 2);
	}
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {
		kem_keygen(pk, &pk_byts, sk, &sk_byts);

		kem_enc(pk, pk_byts, k1, &ss_byts, c, &c_byts);
		kem_dec(sk, sk_byts, c, c_byts, k2, &ss_byts);

		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, (sk_len * 2 + 1), (FILE*)fp);

		for (j = 0; j < sk_len; j++) {
			sk_t[j] = hextodec(buff + 2 * j, 2);
		}
		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		fgets(buff, (pk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pk_len; j++) {
			pk_t[j] = hextodec(buff + 2 * j, 2);
		}

		fgets(buff, 9, (FILE*)fp);
		c_len = hextodec(buff, 8);
		fgets(buff, (c_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < c_len; j++) {
			c_t[j] = hextodec(buff + 2 * j, 2);
		}
		fgets(buff, 9, (FILE*)fp);
		ss_len = hextodec(buff, 8);
		fgets(buff, (ss_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ss_len; j++) {
			k3[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(sk_t, sk, CRYPTO_SECRETKEYBYTES) == 0) {
			//printf("\nsk_t is equal to sk. \n");
		}
		else {
			printf("\nsk_t is not equal to sk. \n");
			label = -1;
		}
		if (memcmp(pk_t, pk, CRYPTO_PUBLICKEYBYTES) == 0) {
			//printf("\npk_t is equal to pk. \n");
		}
		else {
			printf("\npk_t is not equal to pk. \n");
			label = -1;
		}


		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		if (memcmp(c, c_t, CRYPTO_CIPHERTEXTBYTES) == 0) {
			//printf("\nc is equal to c_t. \n");
		}
		else {
			printf("\nc is not equal to c_t. \n");
			label = -1;
		}

		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}

int testkex() {

	FILE *fp = NULL;
	char buff[5000];
	unsigned char seed[48];

	unsigned char pka[CRYPTO_PUBLICKEYBYTES], pkb[CRYPTO_PUBLICKEYBYTES];
	unsigned char ska[CRYPTO_SECRETKEYBYTES], skb[CRYPTO_SECRETKEYBYTES], pa[CRYPTO_SECRETKEYBYTES], pb[CRYPTO_SECRETKEYBYTES];
	unsigned char pa_t[CRYPTO_SECRETKEYBYTES], pb_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], ma[CRYPTO_CIPHERTEXTBYTES], mb[CRYPTO_CIPHERTEXTBYTES], ma_t[CRYPTO_CIPHERTEXTBYTES], mb_t[CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	long long int  error_num = 0;
	unsigned long long pka_byts, ska_byts, pkb_byts, skb_byts, pa_byts, pb_byts, ma_byts, mb_byts, k1_byts, k2_byts;

	unsigned long long pk_byts = 0, sk_byts = 0, c_byts = 0, label = 0;

	fopen_s(&fp, "KEX_VEC_INFO.dat", "r");
	int seed_len = 0, sk_len = 0, pk_len = 0, c_len = 0, ss_len = 0, pa_len = 0, pb_len = 0, ma_len = 0, mb_len = 0;

	fgets(buff, 9, (FILE*)fp);
	seed_len = hextodec(buff, 8);
	fgets(buff, (seed_len * 2 + 1), (FILE*)fp);
	for (j = 0; j < seed_len; j++) {
		seed[j] = hextodec(buff + 2 * j, 2);
	}
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {
		kex_init_a(pka, &pka_byts, ska, &ska_byts, pa, &pa_byts);
		kex_init_b(pkb, &pkb_byts, skb, &skb_byts, pb, &pb_byts);

		// for a
		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		if (sk_len != kex_get_sk_byts()) {
			printf("sk_len is not equal to sk_byts\n");
			label = -1;
		}
		if (pk_len != kex_get_pk_byts()) {
			printf("pk_len is not equal to pk_byts\n");
			label = -1;
		}
		// for b
		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		if (sk_len != kex_get_sk_byts()) {
			printf("sk_len is not equal to sk_byts\n");
			label = -1;
		}
		if (pk_len != kex_get_pk_byts()) {
			printf("pk_len is not equal to pk_byts\n");
			label = -1;
		}
		fgets(buff, 9, (FILE*)fp);
		pa_len = hextodec(buff, 8);
		fgets(buff, (pa_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pa_len; j++) {
			pa_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\npa_t is equal to pa. \n");
		}
		else {
			printf("\npa_t is not equal to pa. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		pb_len = hextodec(buff, 8);
		fgets(buff, (pb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pb_len; j++) {
			pb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\npb_t is equal to pb. \n");
		}
		else {
			printf("\npb_t is not equal to pb. \n");
			label = -1;
		}

		kex_send_a(pkb, pkb_byts, pa, &pa_byts, ma, &ma_byts);
		fgets(buff, 9, (FILE*)fp);
		pa_len = hextodec(buff, 8);
		fgets(buff, (pa_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pa_len; j++) {
			pa_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin send_a pa_t is not equal to pa. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		ma_len = hextodec(buff, 8);
		fgets(buff, (ma_len * 2 + 1), (FILE*)fp);

		for (j = 0; j < ma_len; j++) {
			ma_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin send_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin send_a ma_t is not equal to ma. \n");
			label = -1;
		}


		kex_send_b(pka, pka_byts, ma, ma_byts, pb, &pb_byts, mb, &mb_byts, k1, &k1_byts);
		fgets(buff, 9, (FILE*)fp);
		pb_len = hextodec(buff, 8);
		fgets(buff, (pb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pb_len; j++) {
			pb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\nin send_b pb_t is equal to pb. \n");
		}
		else {
			printf("\nin send_b pb_t is not equal to pb. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		mb_len = hextodec(buff, 8);
		fgets(buff, (mb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < mb_len; j++) {
			mb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(mb_t, mb, mb_byts) == 0) {
			//printf("\nin send_b mb_t is equal to mb. \n");
		}
		else {
			printf("\nin send_b mb_t is not equal to mb. \n");
			label = -1;
		}


		kex_resp_a(mb, mb_byts, pa, &pa_byts, ma, &ma_byts, k2, &k2_byts);

		fgets(buff, 9, (FILE*)fp);
		ma_len = hextodec(buff, 8);
		fgets(buff, (ma_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ma_len; j++) {
			ma_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin resp_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin resp_a ma_t is not equal to ma. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		ss_len = hextodec(buff, 8);
		fgets(buff, (ss_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ss_len; j++) {
			k3[j] = hextodec(buff + 2 * j, 2);
		}

		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		if (memcmp(k3, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k2. \n");
		}
		else {
			printf("\nk3 is not equal to k2. \n");
			label = -1;
		}
	}

	fclose(fp);
	return label;
}

int testake() {

	FILE *fp = NULL;
	char buff[(CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES) * 2 + 1];
	unsigned char seed[48];

	unsigned char pka[CRYPTO_PUBLICKEYBYTES], pkb[CRYPTO_PUBLICKEYBYTES], pka_t[CRYPTO_PUBLICKEYBYTES], pkb_t[CRYPTO_PUBLICKEYBYTES];
	unsigned char ska[CRYPTO_SECRETKEYBYTES], skb[CRYPTO_SECRETKEYBYTES], pa[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb[CRYPTO_SECRETKEYBYTES];
	unsigned char ska_t[CRYPTO_SECRETKEYBYTES], skb_t[CRYPTO_SECRETKEYBYTES], pa_t[CRYPTO_SECRETKEYBYTES + CRYPTO_SECRETKEYBYTES + CRYPTO_BYTES + CRYPTO_CIPHERTEXTBYTES + CRYPTO_PUBLICKEYBYTES], pb_t[CRYPTO_SECRETKEYBYTES];
	unsigned char k1[CRYPTO_BYTES], k2[CRYPTO_BYTES], k3[CRYPTO_BYTES], ma[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES], ma_t[CRYPTO_PUBLICKEYBYTES + CRYPTO_CIPHERTEXTBYTES], mb_t[CRYPTO_CIPHERTEXTBYTES + CRYPTO_CIPHERTEXTBYTES];
	int i, j;
	long long int  error_num = 0;
	unsigned long long pka_byts, ska_byts, pkb_byts, skb_byts, pa_byts, pb_byts, ma_byts, mb_byts, k1_byts, k2_byts;

	unsigned long long pk_byts = 0, sk_byts = 0, c_byts = 0, label = 0;

	fopen_s(&fp, "AKE_VEC_INFO.dat", "r");
	int seed_len = 0, sk_len = 0, pk_len = 0, c_len = 0, ss_len = 0, pa_len = 0, pb_len = 0, ma_len = 0, mb_len = 0;

	fgets(buff, 9, (FILE*)fp);
	seed_len = hextodec(buff, 8);
	fgets(buff, (seed_len * 2 + 1), (FILE*)fp);
	for (j = 0; j < seed_len; j++) {
		seed[j] = hextodec(buff + 2 * j, 2);
	}
	rand_init(seed, 48);
	for (i = 0; i < 10; i++) {

		kex_init_a(pka, &pka_byts, ska, &ska_byts, pa, &pa_byts);
		kex_init_b(pkb, &pkb_byts, skb, &skb_byts, pb, &pb_byts);

		// for a
		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, (sk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < sk_len; j++) {
			ska_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(ska_t, ska, ska_byts) == 0) {
			//printf("\nska_t is equal to ska. \n");
		}
		else {
			printf("\nska_t is not equal to ska. \n");
			label = -1;
		}


		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		fgets(buff, (pk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pk_len; j++) {
			pka_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pka_t, pka, pka_byts) == 0) {
			//printf("\npka_t is equal to pka. \n");
		}
		else {
			printf("\npka_t is not equal to pka. \n");
			label = -1;
		}

		// for b
		fgets(buff, 9, (FILE*)fp);
		sk_len = hextodec(buff, 8);
		fgets(buff, (sk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < sk_len; j++) {
			skb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(skb_t, skb, skb_byts) == 0) {
			//printf("\nskb_t is equal to skb. \n");
		}
		else {
			printf("\nskb_t is not equal to skb. \n");
			label = -1;
		}


		fgets(buff, 9, (FILE*)fp);
		pk_len = hextodec(buff, 8);
		fgets(buff, (pk_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pk_len; j++) {
			pkb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pkb_t, pkb, pkb_byts) == 0) {
			//printf("\npkb_t is equal to pkb. \n");
		}
		else {
			printf("\npkb_t is not equal to pkb. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		pa_len = hextodec(buff, 8);
		fgets(buff, (pa_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pa_len; j++) {
			pa_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\nin init pa_t is equal to pa. \n");
		}
		else {
			printf("\nin init pa_t is not equal to pa. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		pb_len = hextodec(buff, 8);
		fgets(buff, (pb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pb_len; j++) {
			pb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\npb_t is equal to pb. \n");
		}
		else {
			printf("\npb_t is not equal to pb. \n");
			label = -1;
		}

		kex_send_a(pkb_t, pkb_byts, pa, &pa_byts, ma, &ma_byts);
		fgets(buff, 9, (FILE*)fp);
		pa_len = hextodec(buff, 8);
		fgets(buff, (pa_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pa_len; j++) {
			pa_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pa_t, pa, pa_byts) == 0) {
			//printf("\nin send_a pa_t is equal to pa. \n");
		}
		else {
			printf("\nin send_a pa_t is not equal to pa. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		ma_len = hextodec(buff, 8);
		fgets(buff, (ma_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ma_len; j++) {
			ma_t[j] = hextodec(buff + 2 * j, 2);
		}

		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin send_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin send_a ma_t is not equal to ma. \n");
			label = -1;
		}

		kex_send_b(pka_t, pka_byts, ma_t, ma_byts, pb_t, &pb_byts, mb, &mb_byts, k1, &k1_byts);
		fgets(buff, 9, (FILE*)fp);
		pb_len = hextodec(buff, 8);
		fgets(buff, (pb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < pb_len; j++) {
			pb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(pb_t, pb, pb_byts) == 0) {
			//printf("\nin send_b pb_t is equal to pb. \n");
		}
		else {
			printf("\nin send_b pb_t is not equal to pb. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		mb_len = hextodec(buff, 8);
		fgets(buff, (mb_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < mb_len; j++) {
			mb_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(mb_t, mb, mb_byts) == 0) {
			//printf("\nin send_b mb_t is equal to mb. \n");
		}
		else {

			printf("\nin send_b mb_t is not equal to mb. \n");
			label = -1;
		}


		kex_resp_a(mb_t, mb_byts, pa, &pa_byts, ma, &ma_byts, k2, &k2_byts);

		fgets(buff, 9, (FILE*)fp);
		ma_len = hextodec(buff, 8);
		fgets(buff, (ma_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ma_len; j++) {
			ma_t[j] = hextodec(buff + 2 * j, 2);
		}
		if (memcmp(ma_t, ma, ma_byts) == 0) {
			//printf("\nin resp_a ma_t is equal to ma. \n");
		}
		else {
			printf("\nin resp_a ma_t is not equal to ma. \n");
			label = -1;
		}

		fgets(buff, 9, (FILE*)fp);
		ss_len = hextodec(buff, 8);
		fgets(buff, (ss_len * 2 + 1), (FILE*)fp);
		for (j = 0; j < ss_len; j++) {
			k3[j] = hextodec(buff + 2 * j, 2);
		}

		if (memcmp(k1, k2, CRYPTO_BYTES) == 0) {
			//printf("\nk1 is equal to k2. \n");
		}
		else {
			printf("\nk1 is not equal to k2. \n");
			label = -1;
		}

		if (memcmp(k3, k1, CRYPTO_BYTES) == 0) {
			//printf("\nk3 is equal to k1. \n");
		}
		else {
			printf("\nk3 is not equal to k1. \n");
			label = -1;
		}
	}


	fclose(fp);
	return label;
}